/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */


package com.funambol.mailclient.ui.controller;

import com.funambol.mail.Message;
import com.funambol.mailclient.loc.Localization;
import com.funambol.mailclient.ui.view.FunCanvasViewMessage;
import com.funambol.util.Log;
import com.funambol.util.BasicSyncListener;

public class MailSyncSingleMessageListener extends BasicSyncListener {

    private Message msg;
    private FunCanvasViewMessage msgView;
   
    /** Creates a new instance of MailSyncSingleMessageListener */
    public MailSyncSingleMessageListener(FunCanvasViewMessage msgView) {
        msg = null;
        this.msgView = msgView;
    }

    public void startSession() {

        Log.debug(this, "Start session");

        //DISABLE GetMail Command during sync email
        UIController.enableSyncCommands(false);
    }

    public void itemUpdated(Object item, Object newItem) {

        Log.debug(this, "Item updated");
        msg = (Message)newItem;
    }
 

    public void endSession(int status) {

        Log.debug(this, "End session");
        // If something went wrong then msg may be null, but the setMessage
        // copes with this case, therefore there is no need to duplicate the
        // test
        msgView.setMessage(msg);
        //ENABLE GetMail Command at the end of sync email
        UIController.enableSyncCommands(true);
        
    }

    /**
     * This method does not belong to the SyncListener interface.
     * A multi session is a concept introduced by the SyncClient which is able
     * to perform the sync of multiple repositories.
     *
     * @param repositories repositories to be synchronized
     */
    public void startMultiSession(boolean repositories[]) {}

    /**
     * This method does not belong to the SyncListener interface.
     * A multi session is a concept introduced by the SyncClient which is able
     * to perform the sync of multiple repositories.
     *
     */
    public void endMultiSession() {}
}
