/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.ui.controller.UIController;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;


public class AdCanvas extends Canvas  implements CommandListener { 
    
    
    private FunAd ad;
    
    /** Creates a new instance of AdCanvas */
    public AdCanvas(FunAd ad) {
        this.ad = ad;
        this.addCommand(ad.getActionCommand());
        this.addCommand(ad.getDismissCommand());
        setCommandListener(this);
    }

    protected void paint(Graphics graphics) {
        ad.paintLargeAd(graphics);
    }

    public void commandAction(Command command, Displayable displayable) {
        
        if (command == ad.getActionCommand()) {
            
            ad.doAction();
            
        } else if (command == ad.getDismissCommand()) {
            
            UIController.showInboxScreen();
            //ad.freeMemory();
        }
    }
    
}
