/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package com.funambol.mailclient.ui.view;


import com.funambol.mailclient.cm.Contact;
import com.funambol.mailclient.ui.controller.Theme;
import com.funambol.mailclient.ui.controller.UIController;
import com.funambol.mailclient.loc.Localization;
import com.funambol.util.Log;
import com.funambol.util.StringUtil;
import javax.microedition.io.ConnectionNotFoundException;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.List;
import javax.microedition.rms.RecordStoreException;

/**
 * This list shows all the settings available to the user
 * for this application
 */
public class ContactPhoneNumbersList extends List implements CommandListener {
    
    private Command backCommand;
    private Command callCommand;
    private Contact contact;
    
    /** Creates a new instance of SettingsList */
    public ContactPhoneNumbersList(Contact contact) {
        super(contact.getNickName(), IMPLICIT);
         
        if(!StringUtil.isNullOrEmpty(contact.getMobilePhone())){
            this.append(contact.getMobilePhone(),Theme.getMOBILE_IMG());
        }
        if(!StringUtil.isNullOrEmpty(contact.getHomePhone())){
            this.append(contact.getHomePhone(),Theme.getHOME_IMG());
        }
        if(!StringUtil.isNullOrEmpty(contact.getJobPhone())){
            this.append(contact.getJobPhone(), Theme.getWORK_IMG());
        }
       
        backCommand = UIController.backCommand;
        addCommand(backCommand);
        callCommand = new Command("Call",UIController.COMMAND_TYPE,10);
        setSelectCommand(callCommand);
        addCommand(callCommand);
        setCommandListener(this);
    }
    
    public void commandAction(Command command, Displayable displayable) {
        if (command == callCommand) {
            try {
                UIController.midlet.platformRequest("tel:"+
                        this.getString(getSelectedIndex()));
            } catch (ConnectionNotFoundException ex) {
                ex.printStackTrace();
                Log.error("calling phonenumber: " + ex.toString());
                UIController.showErrorAlert("Error calling phonenumber.");
            } catch (Exception e) {
                e.printStackTrace();
                Log.error("calling phonenumber: " + e.toString());
            }
        } else if (command == backCommand) {
            UIController.showBackScreen();
        } 
    }
}

