/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.ui.controller.Theme;
import com.funambol.mailclient.ui.controller.UIController;
import com.funambol.util.Log;
import java.io.IOException;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;


public class FunAd {
    
    private Image small;
    private Image large;
    
    private Command actionCommand;
    private Command dismissCommand;
    
    private boolean enabled = false;
    
    /** Creates a new instance of FunAd */
    public FunAd() {
        String r =UIController.midlet.getAppProperty("Ads");
        if (r!=null && (r.toLowerCase().trim().equals("true")))  {
            enabled = true;
        }
    }
    /**
     * @return true if the ad is enabled (i.e. if this is an ad-enabled build)
     */
    public boolean isEnabled() {
        return enabled;
    }
    
    private Image getSmallImage() throws IOException {
        
        if (small == null) {
            
            small = Image.createImage(Theme.AD_IMG_SMALL_PATH);
            
        }
        return small;
        
        
    }
    /**
     * return the actioncommand
     */
    public Command getActionCommand() {
        
        if (actionCommand == null) {
            actionCommand =   new Command("Tell Me More", Command.OK,0);
        }
        return actionCommand;
        
        
    }
    /**
     *@return  the dismisscommand
     */
    public Command getDismissCommand() {
        if (dismissCommand == null) {
            dismissCommand = new Command("Close", Command.BACK,0);
        }
        return dismissCommand;
    }
    /**
     * paint the small add on the given graphic at 0,0 position
     */
    public int paintSmallAd(Graphics g) {
        if (enabled) {
            try {
                g.drawImage(getSmallImage(),0,0,g.TOP|g.LEFT);
                return small.getHeight();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return 0;
    }
    
    /**
     * paint the large add on the given graphic at 0,0 position
     */
    public int paintLargeAd(Graphics g) {
        if (enabled) {
            try {
                g.drawImage(getLargeImage(),0,0,g.TOP|g.LEFT);
                return large.getHeight();
            } catch (IOException ex) {
                Log.error("unamble to open image");
                ex.printStackTrace();
            }
        }
        return 0;
    }
    /**
     * perform the action
     */
    public void doAction() {
        
        UIController.openUrl("http://www.starbucks.com");
        Log.info("DoAction!!");
    }
    
    /**
     * free some memory
     */
    public void freeMemory() {
        large = null;
    }
    
    private Image getLargeImage() throws IOException {
        if (large == null) {
            large = Image.createImage(Theme.AD_IMG_LARGE_PATH);
        }
        return large;
    }
    
}
