/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.ui.controller.Theme;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import com.funambol.util.Log;


public class FunSplashScreen extends Canvas{
    
    
    private int BACKGROUND_COLOR = 0xffffff; //white!
    private String [] message = { "Loading..." };
    private Font font = Font.getDefaultFont();
    
    private int FOREGROUND_COLOR = 0x000000;
    private int iconNumber;
    
    private  int width = 0;
    private  int height = 0;
    
    
    /** Creates a new instance of FunSplashScreen */
    public FunSplashScreen() {
        
       
        //#ifndef JVMFullScreen 
        // For P900 device Calling the Canvas.setFullScreenMode(boolean) 
        // method results in an error, 
        // unless it is called in the paint() method.
            this.setFullScreenMode(true);
        //#else
        // In SymUIQ builds need tack width and height for don't
        // have a jump of logo drawing it
            width = getWidth();
            height = getHeight() + 50;
        //#endif
        
        
    }
    
    public void setInitPhase(String message, int iconNumber) {
        this.message[0] = message;
        this.iconNumber = iconNumber;
        Log.info("setting message in splash screen: " + message);
        
        repaint();
        this.serviceRepaints();
    }
    
    public void setInitPhase(String[] message, int iconNumber) {
        
        this.message = message;
        this.iconNumber = iconNumber;
        
        repaint();
        this.serviceRepaints();
        
    }
    
    
    protected void paint(Graphics graphics) {
        
            
        //#ifndef JVMFullScreen
        // for draw the logo in the center screen in the different builds of SymUIQ
            width = getWidth();
            height = getHeight();
        //#else
        // For P900 device Calling the Canvas.setFullScreenMode(boolean) 
        // method results in an error, 
        // unless it is called in the paint() method.
            this.setFullScreenMode(true);
        //#endif
        
        graphics.setColor(BACKGROUND_COLOR);
        
        graphics.fillRect(0, 0, width, height);
        
         graphics.drawImage(Theme.getLogoImage(),
                width/2,
                (height - message.length * font.getHeight())/2,
                Graphics.HCENTER | Graphics.VCENTER );
        
        graphics.setColor(FOREGROUND_COLOR);
        
        for (int i=0; i< message.length; i++) {
            graphics.drawString(
                    message[i],
                    width/2 ,
                    (height + Theme.getLogoImage().getHeight()- message.length * font.getHeight())/2  + i*font.getHeight(),
                    Graphics.HCENTER | Graphics.TOP
                    );
        }
        if (iconNumber == 1) {
            graphics.drawImage(Theme.getCLOSED_PART_IMG(),
                    width/2 - 40,
                    (height - 20),
                    Graphics.HCENTER | Graphics.VCENTER );
        } else if (iconNumber == 2) {
            graphics.drawImage(Theme.getCLOSED_PART_IMG(),
                    width/2 - 40,
                    (height - 20),
                    Graphics.HCENTER | Graphics.VCENTER );
            graphics.drawImage(Theme.getCONTACT_IMG(),
                    width/2 + 40,
                    (height - 20),
                    Graphics.HCENTER | Graphics.VCENTER );
        }
        /*
        for (int i=0; i< message.length; i++) {
            graphics.drawString(
                    message[i],
                    0 ,
                    0  + i*font.getHeight(),
                    Graphics.TOP | Graphics.HCENTER
                    );
        }*/
    }
    
    
}
