/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

package com.funambol.mailclient.ui.view;

import com.funambol.mailclient.ui.controller.Theme;
import com.funambol.mailclient.ui.controller.UIController;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;


public class FunambolAlert extends Alert implements CommandListener {
    //default timeout in milliseconds
    public static final int DEFAULT_TIMEOUT=3000;  //3 sec

    private boolean done;
    
    /** Creates a new instance of FunambolAlert */
    public FunambolAlert(String title, String alertText, AlertType alertType) {
        
        super(title, alertText, Theme.getALERT_IMG(),alertType);
    }

    /**
     * Shows this alert as a modal screen. Not only the screen does not
     * disappear after some time, but the call is also blocking and the method
     * returns only after the user presses "OK".
     *
     * @param display the display
     */
    public void showModal(Display display) {
        setCommandListener(this);
        display.setCurrent(this);
        done = false;
        while (!done) {
            UIController.sleep(500);
        }
    }

    /**
     * Command listener for modal alerts.
     *
     * @param c the command
     * @param d the displayable
     */
    public void commandAction(Command c, Displayable d) {
        if (c == DISMISS_COMMAND) {
            done = true;
        }
    }
}
