/*
 * Copyright (C) 2006-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

package com.funambol.mailclient.ui.view;

import com.funambol.mail.Address;
import com.funambol.mail.Message;
import com.funambol.mailclient.ui.controller.UIController;
import com.funambol.mailclient.ui.utils.Parser;
import com.funambol.mailclient.loc.Localization;
import com.funambol.util.Log;
import java.util.Enumeration;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;
import javax.microedition.lcdui.StringItem;


public class LinkList extends Form implements CommandListener,ItemCommandListener {
    
    private Command openLinkCommand;
    private Command composeMessageCommand;
   
    
    /** Creates a new instance of LinkList */
    public LinkList(String body) {
        super(Localization.getMessages().LINK_LIST_TITLE);
        Enumeration elements=Parser.extractLinks(body).elements();
        
        openLinkCommand=new Command(Localization.getMessages().OPEN_COMMAND, UIController.COMMAND_TYPE,0);
        composeMessageCommand=new Command(Localization.getMessages().COMPOSE_COMMAND_LABEL,UIController.COMMAND_TYPE,0);

        if (!elements.hasMoreElements()) {
            append(Localization.getMessages().LL_NO_LINKS_MESSAGE);
        } else {
            while (elements.hasMoreElements()) {
                String element = (String)elements.nextElement();
                StringItem stringItem =  new StringItem(null,element);
                if((element).indexOf('@') != -1){
                    stringItem.addCommand(composeMessageCommand);
                }else{
                    stringItem.addCommand(openLinkCommand);
                }
                stringItem.setItemCommandListener(this);
                append(stringItem);
                append("\n");
                
            }
            //this.addCommand(openLinkCommand);
            //this.setSelectCommand(openLinkCommand);
        }
        this.addCommand(UIController.backCommand);
        this.setCommandListener(this);
    }
    
    
    
    public void commandAction(Command command, Displayable displayable) {
        if (command==UIController.backCommand) {
            UIController.showBackScreen();
        }
    }

    public void commandAction(Command command, Item item) {
         if (command==openLinkCommand) {
             UIController.openUrl(((StringItem)item).getText());
        }else if(command==composeMessageCommand){
             Address[] to = {new Address(Address.TO,((StringItem)item).getText())};
             Message message = new Message();
             message.setTo(to);
             UIController.updateComposeMessageScreen(message);
             UIController.showComposeMessageScreen(this,UIController.getComposeMessageScreen().subject);
        }
    }
}
